Subject: Re: [PATCH v2] pack-bitmap: remove trace2 region from hot path

From: Derrick Stolee <[email-masked]>
Date: Mon, 26 Sep 2022 13:31:47 -0400

On 9/26/2022 11:01 AM, Ævar Arnfjörð Bjarmason wrote:
> 
> On Mon, Sep 26 2022, Derrick Stolee via GitGitGadget wrote:
> 
>> This is a critical path, and it would be valuable to measure that the
>> time spent in bitmap_for_commit() does not increase when using the
>> commit lookup table. The best way to do that would be to use a mechanism
>> that sums the time spent in a region and reports a single value at the
>> end of the process. This technique was introduced but not merged by [1]
>> so maybe this example presents some justification to revisit that
>> approach.
> 
> Just getting rid of this seems like a good thing for now.
> 
> But aside: Yes, one way to mitigate this rather than removing the
> tracing would be to make it really fast.
> 
> But just skimming pack-bitmap.c do we really need trace2 at the
> granularity of a single commit? Looking at who calls bitmap_for_commit()
> wouldn't something like this sketch-out be much more useful?:

The point of it being where it was to check that we hit the path
custom to the commit lookup extension, hence the test that is removed.

You are proposing a different region entirely, meant to measure the
cost of the entire walk. Maybe that's valuable, but not critical to
this topic.

If you're proposing the high-level traces as an alternative to my
prototype using the trace2 timers, then I'll point out that the timer
approach allows us to determine how much time is being spent checking
for bitmaps versus walking commits, which the regions you provided don't.

Thanks,
-Stolee